"""
File: mypositionallist.py

Positional list utilizing a header node and a trailer node
"""

from node import TwoWayNode

class LinkedPositionalList(object):
    """ Linked implementation of a positional list."""
    
    def __init__(self):
        self._header = TwoWayNode(None, None, None)
        self._trailer = TwoWayNode(None, self._header, None)
        self._header.next = self._trailer
        self._current = self._header
        self._size = 0

    def hasNext(self):
        """ Returns True if the current item has a next item.
            Precondition:  the list is not empty."""

    def hasPrevious(self):
        """ Returns True if the current item has a previous item.
            Precondition:  the list is not empty."""

    def first(self):
        """Moves the cursor to the first item
        if there is one.
        Precondition:  the list is not empty."""

    def last(self):
        """Moves the cursor to the last item
        if there is one.
        Precondition:  the list is not empty."""

    def next(self):
        """Precondition: hasNext returns True.
        Postcondition: The current item is has moved to the right one item"""
        if not self.hasNext():
            raise AttributeError, "No next item"

    def previous(self):
        """Precondition: hasPrevious returns True.
        Postcondition: The current item is has moved to the left one iten"""
        if not self.hasPrevious():
            raise AttributeError, "No previous item"

    def insertAfter(self, item):
        """Inserts item after the current item, or
        as the only item if the list is empty.  The new item is the
        current item."""

    def insertBefore(self, item):
        """Inserts item before the current item, or
        as the only item if the list is empty.  The new item is the
        current item."""

    def getCurrent(self):
        """ Returns the current item without removing it or changing the
        current position.
        Precondition:  the list is not empty"""

    def remove(self):
        """Removes and returns the current item. Making the next item
        the current item if one exists; otherwise the tail item in the
        list is the current item.
        Precondition: the list is not empty."""
        if self._lastItemPos is None:
            raise AttributeError, "No established item to remove"

    def replace(self, newItemValue):
        """Replaces the current item by the newItemValue.
        Precondition: the list is not empty."""

    def isEmpty(self):
        return len(self) == 0

    def __len__(self):
        return self._size

    def __str__(self):
        """Includes items from first through last."""
        result = ""
        probe = self._header.next
        while probe != self._trailer:
            result += str(probe.data) + " "
            probe = probe.next
        return result
